﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Windows;

namespace CryptoCalc
{
    public partial class MainWindow : Window
    {
        private readonly Random rand = new();

        public MainWindow()
        {
            InitializeComponent();
        }

        private void saveButton_Click(object sender, RoutedEventArgs e)
        {
            Transaction dummy = DummyTransaction();
            DBInteraction.SaveData(ref dummy);
        }
        private void saveWalletButton_Click(object sender, RoutedEventArgs e)
        {
            Wallet dummy = DummyWallet();
            DBInteraction.SaveData(ref dummy);
        }

        private void saveButtonFromInput_Click(object sender, RoutedEventArgs e)
        {
            Transaction rd = new(inputCurrency.Text, Convert.ToSingle(inputAmount.Text), inputType.Text);
            DBInteraction.SaveData(ref rd);
        }

        private void readButton_click(object sender, RoutedEventArgs e)
        {
            IEnumerable <Transaction> transactions = ReadTransactionFromDB();
            foreach (Transaction x in transactions)
            {
                Debug.WriteLine($"{x.GetLocalTimeFromUnixTime(x.UnixTime)} *** {x.Currency} - {x.Amount}");
            }
        }
        private void searchButton_Click(object sender, RoutedEventArgs e)
        {
            //IEnumerable<Transaction> transactions = ReadTransactionFromDB("Currency");
            //transactions = DBInteraction.LoadTransactionsOfCurrency(currencyText.Text);
            //transactionsFoundListBox.Items.Clear();
            //foreach (Transaction x in transactions)
            //{
            //    transactionsFoundListBox.Items.Add(x.FullInfo);
            //}
        }

        private IEnumerable<Transaction> ReadTransactionFromDB()
        {
            Transaction t = new();
            DBInteraction.GenericDB<Transaction> db = new();
            return db.LoadAllData(t.DBTableName);
        }

        private Transaction DummyTransaction()
        {
            Transaction t = new();
            t.SaveUnixTimeNow();
            t.Currency = "SOL";
            t.Amount = Convert.ToSingle(30 * rand.NextDouble());
            t.TransactionType = "BUY";
            t.Platform = "Firi";
            t.Note = "Test";
            return t;
        }

        private Wallet DummyWallet()
        {
            Wallet w = new();
            w.SaveUnixTimeNow();
            w.UnixTimeCreated = w.GetUnixTime(new DateTime(rand.Next(2011, DateTime.Now.Year), rand.Next(1,12), rand.Next(1, 28)));
            w.Platform = "Ledger";
            w.Name = "TestWallet";
            w.Currency = "SOL";
            w.Balance = Convert.ToSingle(30 * rand.NextDouble());
            w.DefaultWallet = 0;
            w.Note = "Test";
            return w;
        }


        private void inputAmount_LostFocus(object sender, RoutedEventArgs e)
        {
            inputAmount.Text = inputAmount.Text.Replace(".", ",");
        }

    }
}
